/****************************************************************************************************
	6/96 bob	Updated #includes to support changed GX Library names.
	
	1990 - 1996  Apple Computer, Inc.
	All rights reserved.
****************************************************************************************************/
#include <Types.h>
#include <QuickDraw.h>
#include <Fonts.h>
#include <Windows.h>
#include <Menus.h>
#include <SegLoad.h>
#include <Memory.h>
#include <Desk.h>

#include <GXGraphics.h>
#include "GraphicsLibraries.h"
#include <GXEnvironment.h>

#include <GXTypes.h>
#include <GXLayout.h>
#include "LayoutLibrary.h"
#include "LayoutFeatureConstants.h"

#include "SampleInterface.h"

short MyStrLen(char *x);
static short MyStrLen(x)
char	*x;
	{
	short c = 0;
	while (*x++) c++;
	return c;
	}	/* MyStrLen */

void NumberStyles(WindowPtr sampleWindow)
	{
	/* Variables */
	char		*myString = "Digits: 0123456789";
	gxPoint		myPoint;
	gxRunFeature	gxRunFeature;
	gxShape		layout;
	short		len, level = 0;
	gxStyle		myStyle;
	gxViewPort	aViewPort;
	
	/* Initialization */
	
	myPoint.x = ff(20);
	myPoint.y = ff(80);
	
	aViewPort = GXNewWindowViewPort(sampleWindow);
	SetDefaultViewPort(aViewPort);
	
	len = MyStrLen(myString);
	
	myStyle = NewLayoutStyle((char *) "\pHoefler Text Italic", ff(50), 0, nil, nil, 0, nil);
	gxRunFeature.featureType = numberSpacingType;
	gxRunFeature.featureSelector = monospacedNumbersSelector;
	GXSetStyleRunFeatures(myStyle, 1, &gxRunFeature);
	
	layout = GXNewLayout(
		1, &len, (void *) &myString,
		1, &len, &myStyle,
		1, &len, &level,
		nil, &myPoint);
	GXDrawShape(layout);
	
	gxRunFeature.featureSelector = proportionalNumbersSelector;
	GXSetStyleRunFeatures(myStyle, 1, &gxRunFeature);
	GXMoveShape(layout, 0, ff(75));
	GXDrawShape(layout);
	
	GXDisposeShape(layout);
	GXDisposeStyle(myStyle);
	GXDisposeViewPort(aViewPort);
	}	/* main */
