#ifndef __SAMPLEINTERFACE__
#define __SAMPLEINTERFACE__
/******************************************************************************\
*
* Apple Macintosh Developer Technical Support
*
* Prototypes for each of the gxLine Layout sample routines
*
* Program: DavesFabSamples
* File:    DavesFabSamples.h
*
* by:      Forrest Tanaka
*
* Copyright  1988-1991 Apple Computer, Inc.
* All rights reserved.
*
* 1.0D2 (09/09/93, MD) -- removed FeatureSets prototype.
*
\******************************************************************************/
	
void AngledCaretsAndHilites(WindowPtr sampleWindow);
void AutomaticKerning(WindowPtr sampleWindow);
void BaselineAlignment(WindowPtr sampleWindow);
void CaseSubstitution(WindowPtr sampleWindow);
void ContinuousFlushness(WindowPtr sampleWindow);
void ContinuousJustification(WindowPtr sampleWindow);
void CrossStreamKerning(WindowPtr sampleWindow);
void DirectionOverrides(WindowPtr sampleWindow);
void ExtenderBars(WindowPtr sampleWindow);
void GetGlyphOffsetsExample(WindowPtr sampleWindow);
void GetOffsetGlyphsExample(WindowPtr sampleWindow);
void GlyphStretching(WindowPtr sampleWindow);
void GlyphSubstitutions(WindowPtr sampleWindow);
void GrowingOrShrinkingLines( WindowPtr sampleWindow );
void HangingPunctuation( WindowPtr sampleWindow );
void ImposedWidth( WindowPtr sampleWindow );
void IndicRearrangement( WindowPtr sampleWindow );
void JustifyGlyph( WindowPtr sampleWindow );
void KerningAdjustments(WindowPtr sampleWindow);
void LeftAndRightFactors(WindowPtr sampleWindow);
void LetterSpacing(WindowPtr sampleWindow);
void LigatureDecomposition(WindowPtr sampleWindow);
void LigatureSplits(WindowPtr sampleWindow);
void Ligatures(WindowPtr sampleWindow);
void NumberStyles(WindowPtr sampleWindow);
void OpticalAlignment(WindowPtr sampleWindow);
void SmartSwashes(WindowPtr sampleWindow);
void SplitPolarizedCarets(WindowPtr sampleWindow);
void TrackKerning(WindowPtr sampleWindow);
void UnicodeReordering(WindowPtr sampleWindow);
void UnlimitedGapAbsorption(WindowPtr sampleWindow);
void VerticalLines(WindowPtr sampleWindow);
void VerticalSubstitution(WindowPtr sampleWindow);

enum samples {
		kAngledCaretsAndHilites,
		kAutomaticKerning,
		kBaselineAlignment,
		kCaseSubstitution,
		kContinuousFlushness,
		kContinuousJustification,
		kCrossStreamKerning,
		kDirectionOverrides,
		kExtenderBars,
		kGetGlyphOffsetsExample,
		kGetOffsetGlyphsExample,
		kGlyphStretching,
		kGlyphSubstitutions,
		kGrowingOrShrinkingLines,
		kHangingPunctuation,
		kImposedWidth,
		kIndicRearrangement,
		kJustifyGlyph,
		kKerningAdjustments,
		kLeftAndRightFactors,
		kLetterSpacing,
		kLigatureDecomposition,
		kLigatureSplits,
		kLigatures,
		kNumberStyles,
		kOpticalAlignment,
		kSmartSwashes,
		kSplitPolarizedCarets,
		kTrackKerning,
		kUnicodeReordering,
		kUnlimitedGapAbsorption,
		kVerticalLines,
		kVerticalSubstitution
		};

#endif
