/****************************************************************************************************
	6/96 bob	Updated #includes to support changed GX Library names.
	3/14/93, MD -- changed to use Hoefler Plain
	
	1990 - 1996  Apple Computer, Inc.
	All rights reserved.
****************************************************************************************************/

#include <Types.h>
#include <QuickDraw.h>
#include <Fonts.h>
#include <Windows.h>
#include <Menus.h>
#include <SegLoad.h>
#include <Memory.h>
#include <Desk.h>

#include <GXGraphics.h>
#include "GraphicsLibraries.h"
#include <GXEnvironment.h>

#include <GXTypes.h>
#include <GXLayout.h>
#include "LayoutLibrary.h"

#include "SampleInterface.h"

short MyStrLen(char *x);
static short MyStrLen(x)
char	*x;
	{
	short c = 0;
	while (*x++) c++;
	return c;
	}	/* MyStrLen */

void UnlimitedGapAbsorption(WindowPtr sampleWindow)
	{
	/* Variables */
	char						*myString = "all to space";
	gxGlyphcode					glyphcodes[30];
	gxGlyphJustificationOverride	glyphJustOverride;
	gxLayoutOptions				gxLayoutOptions;
	gxLine						myLine;
	gxPoint						myPoint;
	gxShape						layout;
	short						len, level = 0;
	gxStyle						myStyle;
	unsigned short				firstGlyph, secondGlyph;
	gxViewPort					aViewPort;
	
	/* Initialization */
	
	myPoint.x = ff(30);
	myPoint.y = ff(50);
	
	aViewPort = GXNewWindowViewPort(sampleWindow);
	SetDefaultViewPort(aViewPort);
	
	len = MyStrLen(myString);
	
	InitializeLayoutOptions(&gxLayoutOptions);
	gxLayoutOptions.width = ff(500);
	gxLayoutOptions.just = 0;
	
	myLine.first.x = myLine.last.x = myPoint.x;
	myLine.first.y = 0;
	myLine.last.y = ff(1000);
	GXDrawLine(&myLine);
	
	myLine.first.x = myLine.last.x = myPoint.x + gxLayoutOptions.width;
	GXDrawLine(&myLine);
	
	myStyle = NewLayoutStyle((char *) "\pHoefler Text", ff(50), 0, nil, nil, 0, nil);
	
	layout = GXNewLayout(
		1, &len, (void *) &myString,
		1, &len, &myStyle,
		1, &len, &level,
		&gxLayoutOptions, &myPoint);
	GXDrawShape(layout);
	
	gxLayoutOptions.just = fract1;
	GXSetLayout(layout, 0, nil, nil, 0, nil, nil, 0, nil, nil, &gxLayoutOptions, nil);
	GXMoveShape(layout, 0, ff(75));
	GXDrawShape(layout);
	
	GXGetLayoutGlyphs(layout, glyphcodes, nil, nil, nil, nil, nil, nil);
	GXGetOffsetGlyphs(layout, 3, false, nil, &firstGlyph, &secondGlyph);

	glyphJustOverride.override.beforeGrowLimit = 0;
	glyphJustOverride.override.afterGrowLimit = 0;
	glyphJustOverride.override.beforeShrinkLimit = 0;
	glyphJustOverride.override.afterShrinkLimit = 0;

	glyphJustOverride.glyph = glyphcodes[firstGlyph];
	glyphJustOverride.override.growFlags = gxOverrideUnlimited + gxUnlimitedGapAbsorption;
	glyphJustOverride.override.shrinkFlags = 0;
	GXSetStyleRunGlyphJustOverrides(myStyle, 1, &glyphJustOverride);
	GXMoveShape(layout, 0, ff(75));
	GXDrawShape(layout);
	
	GXDisposeShape(layout);
	GXDisposeStyle(myStyle);
	GXDisposeViewPort(aViewPort);
	}	/* main */
