/*
 *	Main.h
 *
 *	Robert Dierkes,  November 11, 1993
 *
 *	Change History:
 *
 *	   11/93	???		New
 *	   4/96		bob		Removed unused Macros (GetWindowKind & SetWindowKind)
 *						Added the copyright info.
 *
 *
 *		 Apple Computer, Inc. 1990 - 1996  All rights reserved
 *
 */

#define		kGraphicsHeapSize	(100 * 1024L)

#define		kHiliteAllMenus		(short) 0
#define		kWindowOnTop		((WindowPtr) -1)
#define		kWindowTitleHeight	(short) 20


Boolean	InitApp (void);
void ExitApp (void);
void InitializeMenus (void);
WindowPtr InitializeWindow (void);
void DoContentClick (EventRecord *pEvent, WindowPtr pWindow);
void DoMenuCommand (long menuResult);
void DoGrowBox (EventRecord *pEvent, WindowPtr pWindow);
void DoZoomBox (EventRecord *pEvent, WindowPtr pWindow, short windowPart);
void DoNullEvent (EventRecord *pEvent);
void DoMouseDown (EventRecord *pEvent);
void DoKeyStroke (EventRecord *pEvent);
void DoUpdate (EventRecord *pEvent);
void DoActivate (EventRecord *pEvent);
void DoEvent (void);
