/*
 *	ShapeSetup.h
 *
 *	Robert Dierkes,  April 26, 1993
 *
 *	Change History:
 *
 *	   4/93	???		New
 *	   4/96	bob		Updated #includes to support changed GX Library names.
 *					Changed boolean to Boolean.
 *					Added the copyright info.
 *
 *
 *		 Apple Computer, Inc. 1990 - 1996  All rights reserved
 *
 */

#include <GXTypes.h>

#define		kRowCount		3
#define		kColumnCount	3

enum
{
	kTrapizoidPolygon,	///
	kOvalPath,
	kArrowPolygon,

	kPatternedPolygon,
	kWordGlyphs,
	kArchCurve,

	kCapsLine,
	kDashedOvalPath,
	kJoinPath,			///

	kShapeCount
};

#define		kFixOneHalf		(fixed1 >> 1)
#define		kHalfInch		IntToFixed (36)
#define		kQuarterInch	IntToFixed (18)
#define		kEigthInch		IntToFixed (9)


Boolean CreateShapesFrame (WindowPtr pWindow, register long numRows, register long numCols,
			gxShape *pBoxSet);
Boolean CreateHitTestShapes (WindowPtr pWindow, gxShape **h1stHitShape, gxShape *pBoxSet,
			 register long shapeCount);
void DisposeHitTestShapes (gxShape **h1stHitShape, gxShape *pBoxes);
