#include <Types.h>
#include <QuickDraw.h>
#include <Fonts.h>
#include <Windows.h>
#include <Menus.h>
#include <SegLoad.h>
#include <Memory.h>
#include <Desk.h>

#include <GXGraphics.h>
#include "GraphicsLibraries.h"
#include <GXEnvironment.h>

#include <GXTypes.h>
#include <GXLayout.h>
#include "LayoutLibrary.h"
#include "LayoutFeatureConstants.h"

#include "SampleInterface.h"

short MyStrLen(char *x);
static short MyStrLen(x)
char	*x;
	{
	short c = 0;
	while (*x++) c++;
	return c;
	}	/* MyStrLen */

void VerticalSubstitution(WindowPtr sampleWindow)
	{
	/* Variables */
	char			*myString = "(note change)";
	gxLayoutOptions	gxLayoutOptions;
	gxPoint			myPoint;
	gxRunFeature		gxRunFeature;
	gxShape			layout;
	short			len, level = 0;
	gxStyle			myStyle;
	gxViewPort		aViewPort;
	
	/* Initialization */
	
	myPoint.x = ff(20);
	myPoint.y = ff(50);
	
	aViewPort = GXNewWindowViewPort(sampleWindow);
	SetDefaultViewPort(aViewPort);
	
	len = MyStrLen(myString);
	InitializeLayoutOptions(&gxLayoutOptions);
	
	myStyle = NewLayoutStyle((char *) "\pvsTimes Roman", ff(40), 0, nil, nil, 0, nil);
	
	layout = GXNewLayout(
		1, &len, (void *) &myString,
		1, &len, &myStyle,
		1, &len, &level,
		&gxLayoutOptions, &myPoint);
	GXDrawShape(layout);

	GXRotateShape(layout, ff(90), ff(0), ff(0));
	gxRunFeature.featureType = verticalSubstitutionType;
	gxRunFeature.featureSelector = verticalSubstitutionOffSelector;
	GXSetStyleRunFeatures(myStyle, 1, &gxRunFeature);
	GXSetStyleTextAttributes(myStyle, gxVerticalText);
	GXMoveShape(layout, ff(80), ff(60));
	GXDrawShape(layout);
	
	gxRunFeature.featureSelector = verticalSubstitutionOnSelector;
	GXSetStyleRunFeatures(myStyle, 1, &gxRunFeature);
	GXMoveShape(layout, ff(150), 0);
	GXDrawShape(layout);
	
	GXDisposeShape(layout);
	GXDisposeStyle(myStyle);
	GXDisposeViewPort(aViewPort);
	}	/* main */
